######################################
## Systemic Coder
#
#  File: ExportLabeller.tcl
#  Author: Mick O'Donnell micko@wagsoft.com
#
#  Copyright: the author grants you a limited, nonexclusive, royalty-free 
#  right to reproduce and distribute this file; provided, however, that 
#  use of such software shall be subject to the terms and conditions of 
#  the Systemic Coder License Terms, a copy of which may be viewed at:
#  http://www.wagsoft.com/Coder/copyright.txt
#  This notice must not be removed from the software, and in the event
#  that the software is divided, it should be attached to every part.

proc out {file} {
    global TEXT_NODES NODE SYSTEM
    set features [list advice informative warning info-seeker title supporting address phatic]
    if [file exists $file] {file delete $file}

    set f [open $file w]
    foreach itm $TEXT_NODES {
	set text $NODE($itm,text)
	
	set stage [car [intersection $features $NODE($itm,features)]]
	if { $stage == "supporting"} {
	    set stage [intersection $SYSTEM(SUPPORTED-UNIT,features) $NODE($itm,features)]
	    set stage [car [split $stage "-"]]
	}
	if { $stage == {}} {
	    set stage unknown
	}
	regsub -all {\-} $stage "_" stage
	puts $f "#$stage\n$text"
    }
    
    # Close the file
    close $f
}
