######################################
## Systemic Coder
#
#  File: File.tcl
#  Author: Mick O'Donnell micko@wagsoft.com
#
#  Copyright: the author grants you a limited, nonexclusive, royalty-free 
#  right to reproduce and distribute this file; provided, however, that 
#  use of such software shall be subject to the terms and conditions of 
#  the Systemic Coder License Terms, a copy of which may be viewed at:
#  http://www.wagsoft.com/Coder/copyright.txt
#  This notice must not be removed from the software, and in the event
#  that the software is divided, it should be attached to every part.

proc default-directory {{type {}}} {
    global TEXT_FILE GRAMMAR_FILE DIR TEXTS SCHEMES ANALYSES CODINGS_FILE

    switch -- $type {
	text {
	    if [valid-filevar-p TEXT_FILE] {
		return [file dirname $TEXT_FILE]
	    }
	    
	    return $TEXTS
	}
	grammar -
	scheme {
	    if [valid-filevar-p GRAMMAR_FILE] {
		return [file dirname $GRAMMAR_FILE]
	    }
	    
	    return $SCHEMES
	}
	
	analyses {
	    if [valid-filevar-p CODINGS_FILE] {
		return [file dirname $CODINGS_FILE]
	    }
	   
	    return $ANALYSES
	}
    }
    
    return  $DIR
}
    
