######################################
## Systemic Coder
#
#  File: Globals.tcl
#  Author: Mick O'Donnell micko@wagsoft.com
#
#  Copyright: the author grants you a limited, nonexclusive, royalty-free 
#  right to reproduce and distribute this file; provided, however, that 
#  use of such software shall be subject to the terms and conditions of 
#  the Systemic Coder License Terms, a copy of which may be viewed at:
#  http://www.wagsoft.com/Coder/copyright.txt
#  This notice must not be removed from the software, and in the event
#  that the software is divided, it should be attached to every part.


#########################
# FONTS

global TEXT_FONT_SIZE TEXT_LINES TINY_FONT PLATFORM TEXT_FONT CHOICE_FONT

set TEXT_FONT_SIZE 12 ; # size of text in text window
set TEXT_LINES 3 ; # number of lines in text window
set TEXT_FONT "-Adobe-Times-Plain-R-Normal--16-160-*-*-*-*-*-*"

switch -- $PLATFORM {
  unix    {
      set TINY_FONT "-Adobe-Times-Plain-R-Normal--10-100-*-*-*-*-*-*"
      set CHOICE_FONT "-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*"
  }
  windows {
      set TINY_FONT "Times 7"
      set CHOICE_FONT "-Adobe-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*"
  }
  default {
      set CHOICE_FONT "-Adobe-Times-Plain-R-Normal--*-120-*-*-*-*-*-*"
      set TINY_FONT "-Adobe-Times-Plain-R-Normal--7-70-*-*-*-*-*-*"
  }
}

#######################
# FILES

global CODINGS_FILE TEXT_FILE 
set CODINGS_FILE {}
set TEXT_FILE {}

#######################
# OPTIONS

global AUTO_ADVANCE SELECT_ON_CLICK IGNORE_COMPLETE REVIEW_FILTER STATS_FILTER  SHOW_CONTEXT COLOR_SCHEMES CODING_COL_WIDTH\
	MAX_LABEL_WIDTH

set AUTO_ADVANCE 1
set IGNORE_COMPLETE 0
set SELECT_ON_CLICK 1
set REVIEW_FILTER {}
set STATS_FILTER {}
set SHOW_CONTEXT 2
set COLOR_SCHEMES {{#FCD98E #F6C19E} {#1E84D2 #0073CA} }
set CODING_COL_WIDTH 125
set MAX_LABEL_WIDTH 18
