
proc search-files-for-string {} {
    global SRC
    set string [ask-user-for-string  "String to search for?"]
    if { $string == 0} {return}

    find-string-in-dir $string $SRC ".tcl"
}

proc find-string-in-dir {string dir ext} {
    if [winfo exists .fsid] {destroy .fsid}
    
    scrolled-text-dialog-nonmodal .fsid "Search: $string" ""
    .fsid.text tag configure filename -foreground red
    .fsid.text tag configure hit -foreground green
    set file {}
    foreach result [find-string-in-dir.1 $string $dir $ext] {
	if { [lindex $result 0] != $file} {
	    set file [lindex $result 0]
	    .fsid.text insert end "\nFile: $file\n" {filename}
	}
	.fsid.text insert end "  [lindex $result 1]\n"
    }
    .fsid.text see 1.0
    return
    
}

proc find-string-in-dir.1 {string dir {ext .*}} {
    set results {}
    foreach file [glob -nocomplain $dir/*$ext] {
	set results [concat $results [find-string-in-file $string $file]]
    }
    foreach dir [glob -nocomplain  $dir/*] {
	if [file isdir $dir] {
	    set results [concat $results [find-string-in-dir.1 $string $dir $ext]]
	}
    }
    return $results
}

proc find-string-in-file {string file} {
    set results {}
    set str [open $file r]
    set count 0
    while { [gets $str line] > -1 } {
	incr count
	if {[string first $string $line] > -1} {
	    lappend results [list $file $line $count]
	}
    }
    close $str
    return $results
}

