
proc GetValue { string {startvalue {} } {xpos {}} {ypos {}} } {
    global prompt
    set prompt(result) $startvalue
    set f [toplevel .prompt -borderwidth 10]
    if { $xpos != {} && $ypos != {} } {wm geometry .prompt "+$xpos+$ypos"}

    message $f.msg -text $string
    entry $f.entry -textvariable prompt(result) -bg white
    $f.entry selection range 0 end
    set b [frame $f.buttons -bd 10]
    pack $f.msg $f.entry $f.buttons -side top -fill x
    
    button $b.ok -text OK -command {set prompt(ok) 1} \
	    -underline 0
    button $b.cancel -text Cancel -command {set prompt(ok) 0} \
	    -underline 0
    pack $b.ok -side left
    pack $b.cancel -side right
    
    foreach w [list $f.entry $b.ok $b.cancel] {
	bindtags $w [list .prompt [winfo class $w] $w all]
    }
    bind .prompt <Alt-o> "focus $b.ok ; break"
    bind .prompt <Alt-c> "focus $b.cancel ; break"
    bind .prompt <Alt-Key> break
    bind .prompt <Return> {set prompt(ok) 1}
    bind .prompt <Control-c> {set prompt(ok) 0}

    tkwait visibility .prompt
    focus -force $f.entry
    grab $f
    wm transient $f .
    if { $xpos != {} && $ypos != {} } {ensure-visible .prompt $xpos $ypos}
    tkwait variable prompt(ok)
    grab release $f
    destroy $f
    if {$prompt(ok)} {
	return $prompt(result)
    } else {
	return {}
    }
}

