
proc addsap {text {tag {} }} {
    .sap.text insert end $text $tag
}


proc show-all-procs {startdir} {
    global SAP_DEFS
    if [winfo exists .sap] {destroy .sap}
    scrolled-text-dialog-nonmodal .sap "Show Procs" "All Processes\n=====================\n" -wrap none
    .sap.text tag config procname -foreground blue
    .sap.text tag config procargs -foreground "dark green"

    set SAP_DEFS {}
    foreach file [all-files-under $startdir "*.tcl"] {
	extract-proc-lines $file
    }
    show-sap-results $SAP_DEFS
}

proc all-files-under {dir {pattern "*"}} {
    set result {}
    set result [glob -nocomplain -types {f} $dir/$pattern] 

    foreach dir1 [glob -nocomplain -types {d} $dir/*] {
	concat! result [all-files-under $dir1 $pattern]
    }
    return $result
}

proc extract-proc-lines {file} {
    global SAP_DEFS
    set text [read-file $file]
    set lines [split $text "\n"]
    foreach line $lines {
	set line [string trim $line]
	if {[string first "proc" $line] == 0} {
	    set line [string range $line 5 end-1]
	    lappend SAP_DEFS [list $line $file]
	}
    }
}

proc show-sap-results {results} {
    set results [lsort  -dictionary $results]
    
    set count 0
    set lastproc {}
    foreach result $results {
	incr count
	set procline [lindex $result 0]
	set file [lindex $result 1]
	set pos [string first " " $procline]
	set proc [string range $procline 0 $pos]
	set args [string range $procline $pos end]

	# Mark repeated procs
	if { $proc == $lastproc} {
	    set char "*"
	} else {
	    set char " "
	}

	addsap " $char $proc " [list $count procname] 
	addsap "   $args" {procargs}
	addsap "   $file\n"
	.sap.text tag bind $count <ButtonRelease> "show-sap-proc $proc \"$file\""
	set lastproc $proc
    }
}

proc show-sap-proc {proc file} {
    if [winfo exists .tmp] {destroy .tmp}
    scrolled-text-dialog-nonmodal .tmp $file [read-file $file]
    set pos [.tmp.text search "proc $proc" 1.0]
    .tmp.text see $pos
}

