


proc scrolled-listbox {name args} {
# Returns a scrollable listbox
# $name.listbox is the actual listbox widger
# $name.title is the title
#
# Args: (as listbox)
  set bg [getarg -bg $args]
  frame $name -bg $bg
  listbox $name.choices -yscrollcommand "$name.scroll set" -selectmode browse	 
  scrollbar $name.scroll -command "$name.choices yview"

  for {set i 0} {$i < [llength $args]} {incr i 2} {
      $name.choices configure [lindex $args $i]\
	      [lindex $args [expr $i + 1]]
  }
  
  pack $name.scroll -side right -fill y 
  pack $name.choices -fill both -expand 1 -side left
  
  # Bind keys and mouseclicks
  # bind $name.choices <MouseWheel> "slb-mousewheel-scroll $name.choices %D"
  return $name
}


proc slb-mousewheel-scroll {win dir} {
    if { $dir > 0 } {
	slb-up-selection $win
    } else {
	slb-down-selection $win
    }
}

proc slb-up-selection {win} {
    set curr [$win index active]
    if { $curr == 0 } {bell; return}
    $win selection clear active
    $win see [incr curr -1]
    $win selection set $curr
    $win activate $curr
}

proc slb-down-selection {win} {
    set curr [$win index active]
    set max  [expr [$win index end] -1]
    if { $curr == $max } {bell; return}
    incr curr
    $win selection clear active
    $win see $curr
    $win selection set $curr
    $win activate $curr
}

proc ScrolledListBoxSelect {path idx} {
    # I am not sure all of these are needed
    $path.choices yview moveto $idx
    $path.choices selection clear 0 end
    $path.choices selection set $idx 
    $path.choices activate $idx
}


proc ScrolledListBoxSelected {path} {
    return [$path.choices get active]
}

proc ScrolledListBoxSet {path choices} {
    # Only to use in tcl8.2
    $path.choices delete 0 end
    eval [concat "$path.choices insert end" $choices]
}

proc ScrolledListBoxAdd {path choice} {
    # Only to use in tcl8.2
    $path.choices insert end $choice
}


