

proc scrolled-text {name args} {
# Returns a scrollable text widget
# $name.text is the actual text widger
#
# Args: (all optional)
# -height <integer>
# -font <font-spec>

  set height [getarg -height $args]
  if { $height == {} } {set height 40}
  frame $name 

  # Place the text
  text  $name.text  -bg white -relief sunken -wrap word -height $height\
	  -yscrollcommand "$name.scroll set" -exportselection true
  scrollbar $name.scroll -command "$name.text yview"

  set font [getarg -font $args]
  if { $font != {} } {
    $name.text configure -font $font
  }

  pack $name.scroll  -side right -fill y 
  pack $name.text  -fill both -expand 1 -side left


  return $name

}

