global BG_COLOR1 BG_COLOR2
if ![info exists BG_COLOR1] {set BG_COLOR1 "#FCD98E"}
if ![info exists BG_COLOR2] {set BG_COLOR2 "#F6C19E"}


proc Toolbar {name {direction vertical}  {label {}}} {
    global ToolbarDir
    set ToolbarDir($name) $direction
    frame $name 
    if { $label != ""} {
	label $name.mylabel -text $label -fg red
	if { $direction == "vertical" } {
	    pack $name.mylabel -side top -anchor nw -fill x
	} else {
	    pack $name.mylabel -side left -anchor nw 
	}
    }
}


proc ToolbarItem {Tbar Text Msg Cmd {height 1}} {
    global ToolbarDir BG_COLOR2 BUTTON_FONT
    set Iname $Tbar.[label-to-name $Text]
    button $Iname -text $Text -command $Cmd -height $height -bg $BG_COLOR2

    if [info exists BUTTON_FONT] {
	$Iname config -font $BUTTON_FONT
    }

    if { $ToolbarDir($Tbar) == "vertical" } {
	pack $Iname -side top -anchor nw -fill x
    } else {
	pack $Iname -side left -anchor nw 
    }

    # Set s a variable which can be displayed in a message display space
    if { $Msg != "" } {
	add-rollover-message $Iname $Msg
    }
    return $Iname
}

proc hideToolbarItem {Tbar Text} {
    global ToolbarDir BG_COLOR2 BUTTON_FONT
    set Iname $Tbar.[label-to-name $Text]
    pack forget $Iname
}

proc unhideToolbarItem {Tbar Text} {
    global ToolbarDir BG_COLOR2 BUTTON_FONT
    set Iname $Tbar.[label-to-name $Text]
    pack $Iname -side top -anchor nw -fill x
}

proc add-rollover-message {wgt message} {
    # Sets a variable to hold rollover message
    # Put a widget in your interface to display it, e.g.,
    # label .lexicon.msg -relief sunken -textvariable ROLLOVER_MSG
    bind $wgt <Enter> "rollover-message \"$message\""
    bind $wgt <Leave> "rollover-message {}"
}

proc rollover-message {message} {
    # Sets a variable to hold rollover message
    # Put a widget in your interface to display it, e.g.,
    # label .lexicon.msg -relief sunken -textvariable ROLLOVER_MSG
    global ROLLOVER_MSG
    set ROLLOVER_MSG $message
}


proc ToolbarSelect {Tbar Text} {
    # If this button is selected, then mark it selected
    # and unmark all others.
    set Iname $Tbar.[label-to-name $Text]
    $Iname configure -relief sunken
    foreach slave [pack slaves $Tbar] {
	if { $slave != "$Tbar.mylabel" && $slave != $Iname } {
	    DeselectToolBarButton $slave
	}
    }
}


proc SelectToolBarButton {button} {
    global BUTTON_FONT_BOLD BG_COLOR1
    $button configure -relief flat -font $BUTTON_FONT_BOLD -bg $BG_COLOR1
}

proc DeselectToolBarButton {button} {
    global BUTTON_FONT BG_COLOR2
    $button configure -relief raised -font $BUTTON_FONT -bg $BG_COLOR2
} 


proc label-to-name {Label} {
    # set Label [string trim $Label]
    regsub -all  {\ } $Label _ Label
    return [string tolower $Label]
}



