

proc show-scatterplot {} {
    global SYSTEM NODE TEXT_NODES
    destroy .splot
    toplevel .splot
    catch {namespace import mclistbox::*}

    # frame so they look like a single widget
    frame .splot.main

    mclistbox .splot.main.table -bd 0 -height 18 -width 95 -font "Courier 10" -columnrelief flat\
	    -labelanchor w  -columnborderwidth 0 -selectcommand "show-selection" \
	    -selectmode single -labelborderwidth 2 -fillcolumn name \
	    -xscrollcommand [list .splot.main.scrollx set]\
	    -yscrollcommand [list .splot.main.scrolly set]\
	    -bg white -columnborderwidth 1 -columnrelief groove
    scrollbar .splot.main.scrolly -orient vertical -command [list .splot.main.table yview]
    scrollbar .splot.main.scrollx -orient horizontal -command [list .splot.main.table xview]
    pack .splot.main.scrolly -side right -fill y
    pack .splot.main.scrollx -side bottom -fill x 
    pack .splot.main.table -fill both -expand true -side left
    pack .splot.main  -fill both -expand true -side left

    # add the columns we want to see
    .splot.main.table column add name -label "Feature" -width 20
    .splot.main.table column add plot -label "Segments"  -width [llength $TEXT_NODES]

    set divider [string repeat "-" [llength $TEXT_NODES]]
    foreach system [all-systems] {
	foreach feature $SYSTEM($system,features) {
	    set plot ""
	    foreach nid $TEXT_NODES {
		if {$NODE($nid,ignore) == 0} {
		    if [member $feature $NODE($nid,features)] {
			append plot "*"
		    } else {
			append plot " "
		    }
		}
	    }
	    .splot.main.table insert end [list $feature $plot]
	}
	.splot.main.table insert end [list "" $divider]
    }
}