######################################
## Coder 2.0
#
#  File: Options.tcl
#  Author: Mick O'Donnell micko@dai.ed.ac.uk
#
#  Copyright: the author grants you a limited, nonexclusive, royalty-free 
#  right to reproduce and distribute this file; provided, however, that 
#  use of such software shall be subject to the terms and conditions of 
#  the RSTTool License Terms, a copy of which may be viewed at:
#  http://www.dai.ed.ac.uk/staff/personal_pages/micko/RSTTool/copyright.html
#  This notice must not be removed from the software, and in the event
#  that the software is divided, it should be attached to every part.




proc graph-options {} {
    global  XINCR YINCR  TEMP_XINCR TEMP_YINCR 
    
    set f [modal-dialog .goptions ]
    # wm geometry $f +20+40
    label $f.title -text "Graph Draw Options"  
    set TEMP_XINCR $XINCR
    set TEMP_YINCR $YINCR

    LabelledEntry $f.xincr "X Spacing" TEMP_XINCR
    LabelledEntry $f.yincr "Y Spacing" TEMP_YINCR
    pack $f.xincr $f.yincr  -side top -anchor nw
    
    frame $f.buttons  
    button $f.buttons.ok -text "Done" -underline 0 \
	    -command "set-graph-options-action"
    button $f.buttons.cancel -text Cancel -command "return-from-modal $f 0" \
	    -underline 0
    bind $f <Return> "set-graph-options-action"
    bind $f <Control-c> "return-from-modal $f 0"
    
    pack $f.buttons.ok $f.buttons.cancel  -padx 15 -side left
    pack $f.buttons -pady 10
    post-modal $f
}

proc set-graph-options-action {} {
    global  XINCR YINCR  TEMP_XINCR TEMP_YINCR 
    set TEMP_XINCR [string trim $TEMP_XINCR]
    if ![integer-p $TEMP_XINCR] {
	tell-user "X increment must be an integer value"
	return
    }
    set XINCR $TEMP_XINCR


    set TEMP_YINCR [string trim $TEMP_YINCR]
    if ![integer-p $TEMP_YINCR] {
	tell-user "Y increment must be an integer value"
	return
    }
    set YINCR $TEMP_YINCR   

    return-from-modal .goptions 1
    graph-scheme
}

