# Grapher module: presents in a WinFileExplorer manner

register-grapher "Outline Tree" outline-graph


proc outline-graph {feature} {
    global OCOUNT
    set OCOUNT 1
    catch "unpack-graphframe"
    if [winfo exists .scheme.treeframe] {destroy .scheme.treeframe}
    TreeWidget .scheme.treeframe
    pack .scheme.treeframe -side right -fill both -expand true -anchor n -padx 2
    
    outline-add-feature $feature ""
}

proc outline-add-feature {feature path} {
    global FEATURE SYSTEM OCOUNT
    set newpath "$path/$OCOUNT"
    TreeAdd .scheme.treeframe $path $OCOUNT $feature 
    if [info exists FEATURE($feature,realisations)] {
	set index 1
	foreach real [split $FEATURE($feature,realisations) "\n;"] {
	    TreeAdd .scheme.treeframe $newpath $index "$real"
	    incr index
	} 
    }
    incr OCOUNT
    foreach system $FEATURE($feature,extenders) {
	if [simple-ec-p $SYSTEM($system,ec)] {
	    outline-add-system $system $newpath 
	} else {
	    outline-add-complex $system 
	} 
    }
}

proc outline-add-system {system path} {
    global FEATURE SYSTEM OCOUNT
    TreeAdd .scheme.treeframe $path $OCOUNT "System: $system"
    set newpath "$path/$OCOUNT"
    incr OCOUNT
    foreach feature $SYSTEM($system,features) {
	outline-add-feature $feature $newpath
    }
}

proc outline-add-complex {system} {
    global  OCOUNT SYSTEM
    set label [le-to-label $SYSTEM($system,ec)]
    TreeAdd .scheme.treeframe "" $OCOUNT $label
    set path "/$OCOUNT"
    incr OCOUNT
    outline-add-system $system $path
}

proc le-to-label {le} {
    regsub -all "\{" $le "" le
    regsub -all "\}" $le "" le
    regsub -all "  " $le " " le
    switch --  [pop le] {
	"and" {
	    regsub -all " " $le {\&} le
	}
	"or" {
	    regsub -all " " $le "/" le
	}
    }
    return $le
}
    
