######################################
## RSTTool2.0 & Coder3.0
#
#  Author: Mick O'Donnell micko@wagsoft.com
#
#  Copyright: the author grants you a limited, nonexclusive, royalty-free 
#  right to reproduce and distribute this file; provided, however, that 
#  use of such software shall be subject to the terms and conditions of 
#  the RSTTool License Terms, a copy of which may be viewed at:
#  http://www.wagsoft.com/RSTTool/copyright.html
#  This notice must not be removed from the software, and in the event
#  that the software is divided, it should be attached to every part.


proc load-module {Path Files} {
    global LOADCOUNT
    set ext ".tcl"
    if ![info exists LOADCOUNT] {set LOADCOUNT 0}
    
    foreach file $Files {
	puts "Loading $file$ext"
	source [file join $Path $file$ext]
	if [winfo exists .progress] {ProgressBar .progress.bar update [incr LOADCOUNT]}
    }
}


proc open-load {files} {
    global PICT_DIR TOOL_VERSION OPENING_GRAPHIC
    set opener [image create photo -file [file join $PICT_DIR $OPENING_GRAPHIC]]
    set windim [wm maxsize .]
    canvas .c -height [image height $opener] -width [image width $opener]
    .c create image 0 0 -anchor nw -image $opener
   
    # Show the Progress bar
    frame .progress
    label .progress.label -text "Loading Files: "
    ProgressBar .progress.bar init 0 $files
    
    pack .progress.label .progress.bar -side left
    
    text .credits -bg white -height 3
    .credits insert 1.0 "Version $TOOL_VERSION\nProgrammed: by: Mick O'Donnell\nEmail: micko@wagsoft.com    Web: http://www.wagsoft.com/"
    pack .c .credits .progress


    # resize the window
    set xpos [expr ([lindex $windim 0] - [image width $opener]) / 2]
    set ypos [expr ([lindex $windim 1] - [image height $opener] -100) / 2]
     wm geometry . "+$xpos+$ypos"
    update
}



proc close-load {} {
    ProgressBar .progress.bar done
    pack forget  .progress
    destroy .progress
}


proc load-patches {} {
    global DIR
    foreach file [lsort -dictionary [glob -nocomplain "$DIR/Patches/*.tcl"]] {
	source $file
    }
}
