
proc def-interface {name title rollovermsg frame  {openproc {}} {closeproc {}}} {
    global INTERFACE BUTTON_FONT BG_COLOR1
    set INTERFACE($name,frame) $frame
    set INTERFACE($name,title) $title
    set INTERFACE($name,button)\
	    [ToolbarItem .top.toolbar $title $rollovermsg "install-interface $name" 2]
    
    .top.toolbar config -bg $BG_COLOR1
    $INTERFACE($name,button) config -font $BUTTON_FONT
    set INTERFACE($name,openproc) $openproc
    set INTERFACE($name,closeproc) $closeproc
}

proc install-interface {interface} {
    global CURRENT_INTERFACE INTERFACE

    if {$CURRENT_INTERFACE == $interface} {return}
    if { $CURRENT_INTERFACE != {} } {
	uninstall-interface $CURRENT_INTERFACE
    } 

    set CURRENT_INTERFACE $interface
    toggle-button $interface "flat"
    
    if [info exists INTERFACE($interface,frame)] {
	pack  $INTERFACE($interface,frame) -side top -expand t -fill both
	if { $INTERFACE($interface,openproc) != {}} {$INTERFACE($interface,openproc) }
    } else {
	tell-user "install-interface: No interface for $interface"
    }
}


proc uninstall-interface {{interface {}}} {
    global INTERFACE CURRENT_INTERFACE

    if { $interface == {} } {set interface $CURRENT_INTERFACE}
    if { $interface == {} } {return}
    set CURRENT_INTERFACE {}
    toggle-button $interface "raised"
    if [info exists INTERFACE($interface,frame)] {
	if {$INTERFACE($interface,closeproc) != {} } { $INTERFACE($interface,closeproc)}
	pack forget $INTERFACE($interface,frame)
    } else {
	tell-user "uninstall-interface: No interface for $interface"
    }
}

proc toggle-button {interface dir} {
    global INTERFACE BUTTON_FONT BUTTON_FONT_BOLD BG_COLOR1 BG_COLOR2
    if [info exists INTERFACE($interface,button)] {
	$INTERFACE($interface,button) configure -relief $dir
	if { $dir == "flat" } {
	    $INTERFACE($interface,button) configure -font $BUTTON_FONT_BOLD -bg $BG_COLOR1
	} else {
	    $INTERFACE($interface,button) configure -font $BUTTON_FONT -bg $BG_COLOR2
	}
    } else {
	tell-user "toggle-button: No interface for $interface"
    }
}
